#!/usr/bin/env python

try:
    import cPickle as pickle
except ImportError:
    import pickle

import os
import sys

def compare_results(a, b):
    return cmp(a[1], b[1])

if __name__ == "__main__":
    wiki = sys.argv[1]
    if len(sys.argv) > 2:
        correction = int(sys.argv[2])
    else:
        correction = 0

    combined = {}

    print "Looking for polls under", wiki

    for dirpath, dirnames, filenames in os.walk(wiki):
        if os.path.split(dirpath)[-1] == "poll":
            for filename in filenames:
                pathname = os.path.join(dirpath, filename)
                f = open(pathname, "rb")
                try:
                    combined[filename] = pickle.load(f)
                finally:
                    f.close()

    averages = []
    totals = []

    print
    print "Results:"
    for poll, results in combined.items():
        print poll, results
        values = results.values()
        len_values = len(values)
        sum_values = sum(values) + len_values * correction
        averages.append((poll, float(sum_values) / len_values))
        totals.append((poll, sum_values))

    averages.sort(compare_results, reverse=1)
    totals.sort(compare_results, reverse=1)

    print
    print "Results by averages:"
    for poll, result in averages:
        print "%-15s%f" % (poll, result)

    print
    print "Results by totals:"
    for poll, result in totals:
        print "%-15s%d" % (poll, result)

# vim: tabstop=4 expandtab shiftwidth=4
