# -*- coding: iso-8859-1 -*-
"""
    MoinMoin - SiteUpdates Macro

    Inspired by the RecentChanges macro

    @copyright: 2007 by Paul Boddie <paul@boddie.org.uk>
    @license: GNU GPL (v2 or later), see COPYING.txt for details.
"""

from MoinMoin.Page import Page
from MoinMoin.logfile import editlog

Dependencies = []

MAX_ENTRIES = 5

def execute(macro, args):
    request = macro.request

    max_entries = MAX_ENTRIES
    args = args.split(",")
    if args:
        try:
            max_entries = int(args[0])
        except ValueError:
            pass

    pages = {}
    log = editlog.EditLog(request)

    for line in log.reverse():

        if not request.user.may.read(line.pagename):
            continue

        pages[line.pagename] = line

        if len(pages.keys()) >= max_entries:
            break

    output = []

    if pages:
        output.append('<ul class="site-updates">\n')

        lines = pages.values()
        lines.sort()
        lines.reverse()

        for line in lines[:max_entries]:
            page = Page(request, line.pagename)
            link = page.link_to(request, text=page.split_title(request))
            output.append('<li>%s</li>\n' % link)

        output.append('</ul>\n')

    return ''.join(output)

# vim: tabstop=4 expandtab shiftwidth=4
